import { __decorate } from "tslib";
import { html, observable } from '@microsoft/fast-element';
import { FoundationElement } from '@microsoft/fast-foundation';
import { GridProRendererTypes } from '../grid-pro.types';
export class ActionsMenuRenderer extends FoundationElement {
    init(params) {
        if (!params)
            return;
        this.params = params;
    }
    getGui() {
        return this;
    }
    destroy() { }
    refresh(params) {
        return false;
    }
}
__decorate([
    observable
], ActionsMenuRenderer.prototype, "params", void 0);
export const foundationGridProActionsMenuRenderer = ActionsMenuRenderer.compose({
    baseName: 'grid-pro-actions-menu-renderer',
    template: html `
    <foundation-actions-menu
      name="${(x) => x.params.headerName}"
      :definition=${(x) => x.params}
    ></foundation-actions-menu>
  `,
});
export const getActionsMenuDef = (actions, overrideDef = {}, customActionsOpenerName = '⋮', isVertical = false, buttonAppearance) => {
    const actionsMenuDef = {
        cellRenderer: GridProRendererTypes.actionsMenu,
        cellRendererParams: {
            actions,
            buttonAppearance,
            isVertical,
            buttonText: customActionsOpenerName,
        },
        cellStyle: { border: 'none', overflow: 'visible' },
        field: 'actions',
        headerName: 'Actions',
        width: 150,
    };
    return Object.assign(Object.assign({}, actionsMenuDef), overrideDef);
};
